﻿# fuelle-Schritt-2.py  ## Version mit tiefer Liste
# schrittweise Erarbeitung:
### Schritt / Fall 2:
# das neue Stück passt nicht in den Container
# ohne das Stück weiter suchen

# Prädikat zum Testen, ob der Container voll ist.
def ist_voll(container):
    return container[0]==sum(container[1])

### Hilfsfunktion zum Testen der Überfüllung
def wird_zu_voll(stueck, container):
    return container[0]<stueck+sum(container[1])

# Globale Variable für die Stücke:
stuecke=[30,30,30,20,20,20,20]

# Erarbeitung des Funktionskopfes
def fuelle(stuecke, container):
    if ist_voll(container):
        return container
    elif wird_zu_voll(stuecke[0],container):
        return fuelle(stuecke[1:], container)
    return 'kann noch nichts'

### Tests:
def ausgabe(stuecke, container):
    print(stuecke, 'Fassungsvermoegen:', container[0])
    print( 'Ergebnis: ',
           fuelle(stuecke, container ) )
    print('')
    
ausgabe( stuecke, [80, [30,30,20]] ) # Erfolg
ausgabe( [30,30], [80, [30,30]] ) # wird zu voll
ausgabe( [], [80, [30,30]] ) # Misserfolg
ausgabe( stuecke, [80, []] ) # "Standard" ergibt noch Fehler
