﻿# fuelle-Schritt-4-Alternative-ohne-elif-else.py
## Version mit tiefer Liste, ohne elif und else
# schrittweise Erarbeitung:
### Schritt / Fall 4:
# Rekursion auf Listen:
# leere Liste testen

# Prädikat zum Testen, ob der Container voll ist.
def ist_voll(container):
    return container[0]==sum(container[1])

### Hilfsfunktion zum Testen der Überfüllung
def wird_zu_voll(stueck, container):
    return container[0]<stueck+sum(container[1])

### Hilfsfunktion fuelle_ein
def fuelle_ein(stueck, container):
    inhalt=[]+container[1] # echte Kopie erzeugen!
    inhalt.append(stueck)
    return [container[0], inhalt]

# Globale Variable für die Stücke:
stuecke=[30,30,30,20,20,20,20]


def fuelle(stuecke, container):
    if ist_voll(container):
        return container
    if len(stuecke)==0:
        return False
    if wird_zu_voll(stuecke[0],container):
        return fuelle(stuecke[1:], container)
    return fuelle(stuecke[1:], fuelle_ein(stuecke[0], container))

### Tests:
def ausgabe(stuecke, container):
    print(stuecke, 'Fassungsvermoegen:', container[0])
    print( 'Ergebnis: ',
           fuelle(stuecke, container ) )
    print('')
    
ausgabe( stuecke, [80, [30,30,20]] ) # Erfolg
ausgabe( [30,30], [80, [30,30]] ) # wird zu voll
ausgabe( [], [80, [30,30]] ) # Misserfolg
ausgabe( stuecke, [80, []] ) # "Standard"
