﻿# fuelle-greedy-rekursiv-tiefe-liste.py
# Programm zum Füllen eines Containers mit greedy
# Problem der Rekursionstiefe beachten!

# bei dieser Version wird mit einer tiefen Liste gearbeitet

# Globale Variable für die Stücke:
stuecke=[30,30,30,20,20,20,20]
def erzeuge_Container(fassungsvermoegen):
    return [fassungsvermoegen, []]

def fuelle_ein(stueck, container):
    inhalt=[]+container[1] # echte Kopie erzeugen!
    inhalt.append(stueck)
    return [container[0], inhalt]

# Prädikat zum Testen, ob der Container voll ist.
def ist_voll(container):
    return container[0]==sum(container[1])

def wird_zu_voll(stueck, container):
    return container[0]<stueck+sum(container[1])

def fuelle(stuecke, container):
    if ist_voll(container):
        return container
    elif len(stuecke)==0:
        return False
    elif wird_zu_voll(stuecke[0],container):
        return fuelle(stuecke[1:], container)
    else:
        return fuelle(stuecke[1:], fuelle_ein(stuecke[0], container))
    
### Tests:
def ausgabe(stuecke, fassungsvermoegen):
    print(stuecke, 'Fassungsvermoegen:', fassungsvermoegen)
    print( 'Ergebnis: ',
           fuelle(stuecke, [fassungsvermoegen, []] ) )
    print('')
    
ausgabe( stuecke, 80 )
ausgabe( stuecke, 90 )
ausgabe( stuecke, 100 )
